/**********************
 * par Alain VIZZINI
 * cre le 02-06-2002
 * mj le  16-06-2002
 *********************/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

//using AlKryptoKer;
using System.IO;
using System.Text;


namespace KryptoService {

[SoapRpcService]
public class AlKryptWS : System.Web.Services.WebService{
  ///<summary>Constructeur par dfaut</summary>
  public AlKryptWS (){
    /* Construire ici ce dont vous avez besoin pour votre WS */
  }

  ///<summary>Crypte un texte au moyen de AlKryptoKer</summary>
  [WebMethod(Description="Crypte une chaine avec un mot de passe et rentourne un char[]. Utilise DES 64 bits. Lgal dans la pluspart des pays, si a ne l'est pas chez vous, passez votre chemin.")]
    public char[] CrypterCA (String chaine, String mdp) {
    return Crypter (chaine, mdp).ToCharArray();
  }
  ///<summary>Crypte un texte au moyen de AlKryptoKer</summary>
  [WebMethod(Description="Decrypte une chaine avec un mot de passe et rentourne un char[]. Utilise DES 64 bits. Lgal dans la pluspart des pays, si a ne l'est pas chez vous, passez votre chemin.")]
    public String DecrypterCA (char[] chaine, String mdp) {
    return Decrypter (new String(chaine), mdp);
  }


  ///<summary>Crypte un texte au moyen de AlKryptoKer</summary>
  [WebMethod(Description="Crypte une chaine avec un mot de passe. Utilise DES 64 bits. Lgal dans la pluspart des pays, si a ne l'est pas chez vous, passez votre chemin.")]
    public String Crypter (String chaine, String mdp) {
    //Du code pour encoder dans un String et non dans un flux.
    //Comprendre le code suivant n'est ABSOLUMENT pas ncessaire pour comprendre les WebServices
    UnicodeEncoding e = new UnicodeEncoding();

    MemoryStream strIN = new MemoryStream (e.GetBytes(chaine));
    //attention, strIN EN LECTURE SEULE !!
    
    MemoryStream strOUT = new MemoryStream ();

    AKKPasswordHarmonized pwd = new AKKPasswordHarmonized(mdp);

    AlKryptoKer.Crypt (pwd, strIN, strOUT);

    return e.GetString(strOUT.ToArray());
  }
  
[WebMethod(Description="Decrypte une chaine avec un mot de passe. Utilise DES 64 bits. Lgal dans la pluspart des pays, si a ne l'est pas chez vous, passez votre chemin.")]
    public String Decrypter (String chaine, String mdp) {
    UnicodeEncoding e = new UnicodeEncoding();

    MemoryStream strIN = new MemoryStream (e.GetBytes(chaine));
    //attention, strIN EN LECTURE SEULE !!
    
    MemoryStream strOUT = new MemoryStream ();

    AKKPasswordHarmonized pwd = new AKKPasswordHarmonized(mdp);

    AlKryptoKer.DeCrypt (pwd, strIN, strOUT);

    return e.GetString(strOUT.ToArray());
  }
  

  [WebMethod(Description="Le classique 'presque' hello world. On prend un nom en paramtre, et on retourne 'Bonjour -le-nom- !' .")]
    public String Bonjour(String nom){
    return "Bonjour " + nom + " !";
  }
}

}
